<?php 
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class RelFichaTecnicaPrecoVenda {

    protected $utilService;
    protected $RelFichaTecnicaPrecoVendaService;
              
    public function __construct (Services\RelFichaTecnicaPrecoVendaService $RelFichaTecnicaPrecoVendaService, Utilities\Util $utilService) {
        $this->RelFichaTecnicaPrecoVendaService = $RelFichaTecnicaPrecoVendaService;
        $this->utilService = $utilService;
    }
    
    public function find( $request,  $response) {
       
        
        $conditions = $this->utilService->getParamsAsArray($request);
        
        $newConditions = $this->buildParamsRelatorio($conditions);
        $result = $this->RelFichaTecnicaPrecoVendaService->find($newConditions);

        $response->addDataSet(new DataSet("orm00035_RelFichaTecnicaPrecoVenda", $result));
        
        return $response;
    }
    
     
     public function buildParamsRelatorio($conditions){
        $newConditions = null;
        if(!empty($conditions['CDTIPOCUSTO'])) $newConditions[':TIPOCUSTO'] = $conditions['CDTIPOCUSTO'];
        if(!empty($conditions['CDARVPRODI'])) $newConditions[':CDARVPRODI'] = $conditions['CDARVPRODI'];
        if(!empty($conditions['CDARVPRODF'])) $newConditions[':CDARVPRODF'] = $conditions['CDARVPRODF'];
        if(!empty($conditions['CDPRODINI'])) $newConditions[':CDPRODINI'] = $conditions['CDPRODINI'];
        if(!empty($conditions['PRODINI'])) $newConditions[':PRODINI'] = $conditions['PRODINI'];
        if(!empty($conditions['PRODFIN'])) $newConditions[':PRODFIN'] = $conditions['PRODFIN'];
        
        if(empty($conditions['CDFILIAL'])){
            $newConditions[':TCDFILIAL'] = 'T';
        }else{
            $newConditions[':TCDFILIAL'] = null;
            $newConditions[':CDFILIAL'] = implode('_', $conditions['CDFILIAL']);
        }
        
        if(!array_key_exists('CODIGO', $conditions)) {
            $newConditions[':CDTABEPREC'] = '';
            $newConditions[':TCDTABEPREC'] = 'T';
        } else {
            $newConditions[':CDTABEPREC'] = implode('_', $conditions['CODIGO']);
            $newConditions[':TCDTABEPREC'] = '';
        }
        
        if(!array_key_exists('CDLOJA', $conditions)) {
            $newConditions[':CDLOJA'] = '';
            $newConditions[':TCDLOJA'] = 'T';
        } else {
            $newConditions[':CDLOJA'] = implode('_', $conditions['CDLOJA']);
            $newConditions[':TCDLOJA'] = '';
        }
        
        if (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'I'){
           if (empty($conditions['CDARVPRODI'])){
                $newConditions[':CDARVPRODF'] = $conditions['CDARVPRODI'];
           }
           $newConditions[':TCDPRODUTO'] = null;
           $newConditions[':CDPRODLIST'] = null;
           $newConditions[':PRODNIV'] = null;
        }elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'D') {
           $newConditions[':PRODNIV'] = str_replace('%', '', str_replace('.', '', $conditions['PRODNIV'])).'%';
           $newConditions[':TCDPRODUTO'] = null;
           $newConditions[':CDPRODLIST'] = null;
           $newConditions[':CDARVPRODF'] = null;
           $newConditions[':CDARVPRODI'] = null;
        }
        elseif (isset($conditions['INTERVALISTA']) && $conditions['INTERVALISTA'] == 'L'){
           $newConditions[':CDPRODLIST'] = implode('_', $conditions['CDPRODUTO']);
           $newConditions[':TCDPRODUTO'] = null;
           $newConditions[':CDARVPRODF'] = null;
           $newConditions[':CDARVPRODI'] = null;
           $newConditions[':PRODNIV'] = null;
        }
        else{
           $newConditions[':TCDPRODUTO'] = 'T';
           $newConditions[':CDPRODLIST'] = null;
           $newConditions[':CDARVPRODF'] = null;
           $newConditions[':CDARVPRODI'] = null;
           $newConditions[':PRODNIV'] = null;
        }

        return $newConditions;
     }
}