<?php

namespace Teknisa\MAN\Services;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;
use \Setforms2\Shared\ORM\DateTime;

class AudTaxControllerService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
    
    public function findSalesToAudTax($CDFILIAL, $NRORG, $IDSENDAUDTAX, $DTENTRVENDAINI, $DTENTRVENDAFIN){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':NRORG' => $NRORG,
            ':IDSENDAUDTAX' => $IDSENDAUDTAX,
            ':DTENTRVENDAINI' => $DTENTRVENDAINI,
            ':DTENTRVENDAFIN' => $DTENTRVENDAFIN
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_SALES_TO_AUDTAX, $params);
    }
	
	public function getKeyToken($NRORG){
        $params = array(
           ':NRORG' => $NRORG
        );
        return $this->entityManager->getConnection()->fetchAll(self::GET_CONFIG_AUDTAX, $params)[0];
	}
	
	public function setSendAudTax($CDFILIAL, $CDCAIXA, $NRSEQVENDA, $NRSEQUMOVI, $NRORG, $FLAG){
        $params = array(
            ':CDFILIAL' => $CDFILIAL,
            ':CDCAIXA' => $CDCAIXA,
            ':NRSEQVENDA' => $NRSEQVENDA,
            ':NRSEQUMOVI' => $NRSEQUMOVI,
            ':NRORG' => $NRORG,
            ':IDSENDAUDTAX' => $FLAG
        );
        return $this->entityManager->getConnection()->executeQuery(self::SET_IDSENDAUDTAX, $params);
	}
	
	const GET_SALES_TO_AUDTAX= "
       SELECT M.IDSENDAUDTAX, TO_CHAR(FILOCAVE.DTENTRVENDA, 'DD/MM/YYYY') AS DATAEDITADA, TO_CHAR(FILOCAVE.DTENTRVENDA, 'YYYY-MM-DD') AS DATATOSEND,
              M.NRCARTBANCO, M.NRSEQUMOVI, T.IDTIPORECE, FILOCAVE.CDLOJA || ' - ' || FILOCAVE.NMLOJA AS LABELLOJA,
              FILOCAVE.CDFILIAL || ' - ' || FILOCAVE.NMFILIAL AS LABELFILIAL, FILOCAVE.CDLOJA, FILOCAVE.NMFILIAL, FILOCAVE.NMLOJA,
              FILOCAVE.CDFILIAL, FILOCAVE.NRORG, FILOCAVE.NRSEQVENDA, FILOCAVE.DTENTRVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NRCUPOMFIS,
              M.QTPARCRECEB, M.CDNSUHOSTTEF, M.NRAUTORIZATEF, M.VRMOVIVEND, M.IDTIPOMOVIVE, M.CDTIPORECE, T.NMTIPORECE, FILOCAVE.NRINSJURFILI,
              SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL, 0))) - NVL(I.VRDESITVEND, 0) + NVL(I.VRACRITVEND, 0), 2)) AS VALOR
         FROM ITEMVENDA I
         JOIN (SELECT V.IDSITUVENDA, V.NRSEQVENDA, FILOCA.CDCAIXA, FILOCA.NMCAIXA, FILOCA.CDLOJA, FILOCA.NMLOJA, FILOCA.CDFILIAL, FILOCA.NMFILIAL,
                      FILOCA.NRORG, V.DTENTRVENDA, V.NRCUPOMFIS, FILOCA.NRINSJURFILI
                 FROM VENDA V
                 JOIN (SELECT C.CDCAIXA, C.NMCAIXA, FILO.CDLOJA, FILO.NMLOJA, FILO.CDFILIAL, FILO.NMFILIAL, FILO.NRORG, FILO.NRINSJURFILI
                         FROM CAIXA C
                         JOIN (SELECT L.CDLOJA, L.NMLOJA, FI.CDFILIAL, FI.NMFILIAL, FI.NRORG, L.CDPRODTAXASERV, FI.NRINSJURFILI
                                 FROM LOJA L
                                 JOIN (SELECT F.CDFILIAL, F.NMFILIAL, F.NRORG, F.NRINSJURFILI
                                         FROM FILIAL F
                                        WHERE F.CDFILIAL = :CDFILIAL
                                          AND F.NRORG =:NRORG ) FI 
                                   ON L.CDFILIAL = FI.CDFILIAL
                                  AND L.NRORG = FI.NRORG) FILO 
                           ON C.CDFILIAL = FILO.CDFILIAL 
                          AND C.CDLOJA = FILO.CDLOJA
                          AND C.NRORG = FILO.NRORG) FILOCA 
                   ON V.CDCAIXA = FILOCA.CDCAIXA
                  AND V.CDLOJA = FILOCA.CDLOJA
                  AND V.CDFILIAL = FILOCA.CDFILIAL
                  AND V.NRORG = FILOCA.NRORG
                WHERE V.IDSITUVENDA = 'O' ) FILOCAVE 
           ON FILOCAVE.CDFILIAL = I.CDFILIAL
          AND FILOCAVE.NRORG = I.NRORG
          AND FILOCAVE.NRSEQVENDA = I.NRSEQVENDA
          AND FILOCAVE.CDCAIXA = I.CDCAIXA
         JOIN MOVCAIXA M ON FILOCAVE.CDFILIAL = M.CDFILIAL
          AND FILOCAVE.NRORG = M.NRORG
          AND FILOCAVE.NRSEQVENDA = M.NRSEQVENDA
          AND FILOCAVE.CDCAIXA = M.CDCAIXA
         JOIN TIPORECE T ON M.CDTIPORECE = T.CDTIPORECE
          AND M.NRORG = T.NRORG
        WHERE M.IDTIPOMOVIVE IN ('E')
          AND T.IDTIPORECE IN ('1', '2', '5')
          AND M.IDMOVCONCILIADA = 'N'
          AND M.CDNSUHOSTTEF IS NOT NULL
          AND M.IDSENDAUDTAX = :IDSENDAUDTAX
          AND FILOCAVE.DTENTRVENDA BETWEEN :DTENTRVENDAINI AND :DTENTRVENDAFIN
        GROUP BY M.NRSEQUMOVI, FILOCAVE.CDLOJA, FILOCAVE.CDFILIAL, FILOCAVE.NRORG, FILOCAVE.NRSEQVENDA, FILOCAVE.NRINSJURFILI, FILOCAVE.DTENTRVENDA, FILOCAVE.CDCAIXA, FILOCAVE.NRCUPOMFIS,
                 M.QTPARCRECEB, M.CDNSUHOSTTEF, M.NRAUTORIZATEF, M.VRMOVIVEND, M.IDTIPOMOVIVE, M.CDTIPORECE, T.NMTIPORECE, FILOCAVE.NMFILIAL, FILOCAVE.NMLOJA, T.IDTIPORECE, M.NRCARTBANCO,
                 M.IDSENDAUDTAX
        ORDER BY FILOCAVE.CDFILIAL, FILOCAVE.CDLOJA, FILOCAVE.CDCAIXA, FILOCAVE.NRCUPOMFIS, FILOCAVE.NRSEQVENDA
    ";
                                  
    const GET_CONFIG_AUDTAX= " 
        SELECT CDTOKENAUDTAX, CDKEYAUDTAX, PROXYAUDTAX, PORTAUDTAX
          FROM PARAMGERAL
        WHERE NRORG = :NRORG
    ";

    const SET_IDSENDAUDTAX = "
        UPDATE MOVCAIXA SET IDSENDAUDTAX = :IDSENDAUDTAX WHERE CDFILIAL = :CDFILIAL AND CDCAIXA = :CDCAIXA AND NRSEQVENDA = :NRSEQVENDA AND NRSEQUMOVI = :NRSEQUMOVI AND NRORG = :NRORG
    ";
}